=== modified file 'bzrlib/inventory.py'
--- bzrlib/inventory.py	2011-12-18 12:46:49 +0000
+++ bzrlib/inventory.py	2012-02-17 16:37:15 +0000
@@ -850,22 +850,6 @@
             descend(self.root, u'')
         return accum
 
-    def directories(self):
-        """Return (path, entry) pairs for all directories, including the root.
-        """
-        accum = []
-        def descend(parent_ie, parent_path):
-            accum.append((parent_path, parent_ie))
-
-            kids = [(ie.name, ie) for ie in parent_ie.children.itervalues() if ie.kind == 'directory']
-            kids.sort()
-
-            for name, child_ie in kids:
-                child_path = osutils.pathjoin(parent_path, name)
-                descend(child_ie, child_path)
-        descend(self.root, u'')
-        return accum
-
     def path2id(self, relpath):
         """Walk down through directories to return entry of last component.
 

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2012-01-30 14:18:22 +0000
+++ bzrlib/workingtree.py	2012-02-17 16:37:15 +0000
@@ -2912,7 +2912,9 @@
         This is the same order used by 'osutils.walkdirs'.
         """
         ## TODO: Work from given directory downwards
-        for path, dir_entry in self.root_inventory.directories():
+        for path, dir_entry in self.iter_entries_by_dir():
+            if dir_entry.kind != 'directory':
+                continue
             # mutter("search for unknowns in %r", path)
             dirabs = self.abspath(path)
             if not isdir(dirabs):

